;    Serial PIC writer program 
;                                           2007 Y.Senta
;
;    This program was remodeling of 'Writer675.asm (V1.24)' that 
;    orange_denshi-san made. Search KEYWORD:"writer509" for detail.
;    Also, I referrd to denshiken-san's 'DUAL648.asm (V1.0)'.
;    Search KEYWORD 'Dual Writer' for detail.

	list		p=16f648a
	#include	<p16f648a.inc>

	__CONFIG	_BODEN_OFF & _CP_OFF &  _MCLRE_OFF & _WDT_OFF & _PWRTE_ON & _LVP_ON & _HS_OSC 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	ORG		0x000
	goto	main

	ORG		0x004
	retfie

;;;;;; for interrupt
	cblock	0x20
	w_temp:1
	status_temp:1
	endc

;;;;;; ram area
	cblock
	buffer:1
	counter:2
	counttmp:1
	advBuff:0	
	advCmd1:1
	advCmd2:1
	advCmd3:1
	advTime:1
	advLatch:1
	advData:8
	advCount:1
	advSum:1
	advLoadCnt:1
	endc

;***** Version string table *****
verstr	addwf	PCL,F
	dt	"W509 Ver.1.24"
strend

verstr2	addwf	PCL,F
	dt	"W648 Ver.0.01"
strend2

;;;;;; hardware config ;;;;;;;;;

; connection setting
;  * you can not use ra6,ra7,rb1,rb2 and rb3 rb4*
;  * but when LVP set, you can use rb4          *

#define	VDDSW  0 ; ra0
#define LEDSW  1 ; ra1
#define CLKSW  3 ; ra3
#define DATSW  2 ; ra2
#define VPPSW  4 ; ra4  ** Open Drain Port **

#define	PGMSW  0 ; rb0
#define MC5SW  5 ; rb5

; clk and data port setting
#define CTLPORT	PORTA
#define CTLTRIS	TRISA

; define for
#define DEFDIRA	~((1<<VDDSW)|(1<<VPPSW)|(1<<LEDSW))
#define DEFDIRB	(~(0x0c|(1<<PGMSW)|(1<<MC5SW)))|0x02

#define DEFOUTA (0<<VDDSW)|(1<<VPPSW)|(1<<LEDSW)|(0<<CLKSW)|(0<<DATSW)
#define DEFOUTB (0<<PGMSW)|(0<<MC5SW)

#define DEFCTLDIR DEFDIRA	; set data and clock port I/O mode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

vddhi macro
	bsf		PORTA,VDDSW
	endm

vddlo macro
	bcf		PORTA,VDDSW
	endm

ledon macro
	bcf		PORTA,LEDSW
	endm
ledoff macro
	bsf		PORTA,LEDSW
	endm

vpphi macro
	bcf		PORTA,VPPSW
	endm

vpplo macro
	bsf		PORTA,VPPSW
	endm

pgmhi macro
	bsf		PORTB,PGMSW
	endm

pgmlo macro
	bcf		PORTB,PGMSW
	endm

mclr5lo macro
	bcf		PORTB,MC5SW
	endm

mclr5hi macro
	bsf		PORTB,MC5SW
	endm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

dathi macro
	bsf		CTLPORT,DATSW
	endm

datlo macro
	bcf		CTLPORT,DATSW
	endm

clkhi macro
	bsf		CTLPORT,CLKSW
	endm

clklo macro
	bcf		CTLPORT,CLKSW
	endm

skipdatlo macro
	btfsc	CTLPORT,DATSW
	endm

skipdathi macro
	btfss	CTLPORT,DATSW
	endm

setdefout macro
	bsf		STATUS,RP0	; Set BANK1
	movlw	DEFCTLDIR	; clk, data: in
	movwf	CTLTRIS
	bcf		STATUS,RP0	; Set BANK0
	endm

setcdout macro
	bsf		STATUS,RP0						; Set BANK1
	movlw	DEFCTLDIR-(1<<CLKSW)-(1<<DATSW)	; clk, data: out
	movwf	CTLTRIS
	bcf		STATUS,RP0	; Set BANK0
	endm

setcout macro
	bsf		STATUS,RP0						; Set BANK1
	movlw	DEFCTLDIR-(1<<CLKSW)			; clk: out
	movwf	CTLTRIS
	bcf		STATUS,RP0	; Set BANK0
	endm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

main
	;; initialize
	clrf	INTCON

	;; I/O port setting
	movlw	DEFOUTA
	movwf	PORTA
	movlw	DEFOUTB
	movwf	PORTB

	bsf		STATUS,RP0
	movlw	DEFDIRA
	movwf	TRISA
	movlw	DEFDIRB
	movwf	TRISB
	bcf		STATUS,RP0

	;; for safty
	clklo
	datlo
	ledoff
	vpplo
	vddlo
	pgmlo
	mclr5lo

	;; disable comparator
	movlw	07H
	movwf	CMCON

	;; serial port setting
	call	eeprom_read
	movwf	bpsno
	call	numbps
	call	setbps

	;; pwm setting
	bsf		STATUS,RP0
	movlw	0x16		; 9220000/(22+1)/4 = 100.2kHz
	movwf	PR2
	bcf		STATUS,RP0
	movlw	0x0b
	movwf	CCPR1L
	movlw	B'00001111'	; PWM mode
	movwf	CCP1CON
	movlw	B'00000100'	; Timer2 ON, Prescale 1:1
	movwf	T2CON

	;; showled
	ledon
	call 	wait100ms
	call 	wait100ms

	btfss	bpsno,2
	ledoff
	call	wait100ms
	call 	wait100ms

	btfsc	bpsno,1
	goto	ledn1
	ledoff
	goto	ledn2
ledn1
	ledon
ledn2
	call	wait100ms
	call 	wait100ms

	btfsc	bpsno,0
	goto	ledn3
	ledoff
	goto	ledn4
ledn3
	ledon
ledn4
	call	wait100ms
	call 	wait100ms

	btfss	bpsno,0
	goto	ledn5
	ledoff
	goto	ledn6
ledn5
	ledon
ledn6
	call	wait100ms
	call 	wait100ms

	ledon
	call	wait100ms
	ledoff

	; main loop
mainloop
	movlw	buffer
	movwf	FSR
	call	recvserial
	andlw	H'FF'			; Framing Error?
	bnz		mainloop
	movf	INDF,W
	sublw	0x10			; Max Command Num.
	bnc		checkexpcmd
	movlw	cmdtble>>8
	movwf	PCLATH
	movf	INDF,W
	addwf	PCL,F
cmdtble	
	goto	command0		; Control Command
	goto	command1		; Single Command
	goto	command2		; Receive Data
	goto	command3		; Internal Timing
	goto	command4		; Send Data
	goto	command5		; External Timing
	goto	command6		; Single Command x N
	goto	command7		; Receive Data x N
	goto	command8		; Advance Write 4
	goto	command9		; Send 20bit for PIC18
	goto	commandA		; Receive 8bit for PIC18
	goto	commandB		; Address Set 24 for PIC18
	goto	commandC		; Table Read N-Byte for PIC18
	goto	commandD		; Data Load 8Byte for PIC18
	goto	commandE
	goto	commandF
	goto	command10

checkexpcmd
	movf	INDF,W
	sublw	0xff			; Max Command Num.
	btfsc	STATUS, Z
	goto	commandFF
	goto	mainloop

;;;;;; subroutine: command ;;;;;;;
;***** [Command 00] Tx Version string and Power control *****
command0
	clrf	INDF
	call	sendserial
	call	recvserial
	movlw	0x00
	subwf	INDF,W
	bz		txver			; Command 00 - 00 Tx Ver. string
	movlw	0x01
	subwf	INDF,W
	bnz		cmd0_2
	call	powupvddvpp		; Command 00 - 01 Power-UP Vdd befor Vpp
	movlw	0x01
	movwf	INDF
	call	sendserial
	goto	mainloop
cmd0_2	
	movlw	0x02
	subwf	INDF,W
	bnz		cmd0_3
	call	powdnvppvdd		; Command 00 - 02 Power-DOWN Vpp befor Vdd
	movlw	0x02
	movwf	INDF
	call	sendserial
	goto	mainloop
cmd0_3	
	movlw	0x03
	subwf	INDF,W
	bnz		cmd0_4
	call	powupvppvdd		; Command 00 - 03 Power-UP Vpp befor Vdd
	movlw	0x03
	movwf	INDF
	call	sendserial
	goto	mainloop
cmd0_4	
	movlw	0x04
	subwf	INDF,W
	bnz		cmd0_5
	call	powdnvddvpp		; Command 00 - 04 Power-DOWN Vdd befor Vpp
	movlw	0x04
	movwf	INDF
	call	sendserial
	goto	mainloop
cmd0_5	
	goto	mainloop

;***** [Command 01] Send One command to PIC *****
command1
	movlw	0x01
	movwf	INDF
	call	sendserial			; Echo back Command 01
	call	recvserial
	movf	INDF,W
	call	sendcommand
	call	sendserial
	goto	mainloop

;***** [Command 02] Send One command to PIC with return DATA *****
command2
	movlw	0x02
	movwf	INDF
	call	sendserial
	call	recvserial
	movf	INDF,W
	call	sendcommand
	call	sendserial
	call	receivedata
	movf	ispData0,W
	movwf	INDF
	call	sendserial 
	movf	ispData1,W
	movwf	INDF
	call	sendserial
	goto	mainloop

;***** [Command 03] Send One command to PIC with wait *****
command3
	movlw	0x03
	movwf	INDF
	call	sendserial		; Echo back Serial-cmd
	call	recvserial
	movf	INDF,W
	movwf	piccommand
	call	sendserial		; Echo back PIC-cmd
	call	recvserial
	movf	INDF,W
	movwf	waitval
	movf	piccommand,W
	call	sendcommand
	movf	waitval,W
	call	wait100usX
	movf	waitval,W
	movwf	INDF
	call	sendserial		; Echo back wait value
	goto	mainloop
	
	cblock
	piccommand:2
	waitval:1
	endc

;***** [Command 04] Send One Command and Two Data to PIC *****
command4
	movlw	0x04
	movwf	INDF
	call	sendserial		; Echo back Serial-cmd
	call	recvserial
	movf	INDF,W
	movwf	piccommand
	call	sendserial		; Echo back PIC-cmd
	call	recvserial
	movf	INDF,W
	movwf	ispData0
	call	sendserial		; Echo back PIC-data1
	call	recvserial
	movf	INDF,W
	movwf	ispData1
	movf	piccommand,W
	call	sendcommand
	call	senddata
	call	sendserial
	goto	mainloop

;***** [Command 05] Send Two command to PIC with wait  *****
command5
	movlw	0x05
	movwf	INDF
	call	sendserial		; Echo back Serial-cmd
	call	recvserial		; Receive PIC command1
	movf	INDF,W			;         and SAVE
	movwf	piccommand		; 
	call	sendserial		; Echo back PIC command1
	call	recvserial		; Receive PIC command2
	movf	INDF,W			;         and SAVE
	movwf	piccommand+1
	call	sendserial		; Echo back PIC command2
	call	recvserial		; Receive Wait value
	movf	INDF,W			;         and SAVE
	movwf	waitval
	movf	piccommand,W	; Send PIC command1
	call	sendcommand		;         to PIC
	movf	waitval,W
	call	wait100usX		; Wait 
	movf	piccommand+1,W	; Send PIC command2
	call	sendcommand		;         to PIC
	movf	waitval,W
	movwf	INDF
	call	sendserial		; Echo back wait value
	goto	mainloop

;***** [Command 06] Send One command to PIC w/o wait N-times *****
command6
	movlw	0x06
	movwf	INDF
	call	sendserial		; Echo back Serial Cmd
	call	recvserial
	movf	INDF,W
	movwf	piccommand
	call	sendserial		; Echo back PIC Cmd
	call	recvserial
	movf	INDF,W
	movwf	counter
	call	sendserial		; Echo back Counter-L
	call	recvserial
	movf	INDF,W
	movwf	counter+1
	movwf	counttmp
	
	comf	counter,F		; 2's complement counter
	comf	counter+1,F
	incfsz	counter,F
	goto	cmd6a
	incf	counter+1,F
cmd6a	
	movf	piccommand,W
	call	sendcommand		; Send PIC Command
	
	incfsz	counter,F		; Count N-times
	goto	cmd6a
	incfsz	counter+1,F
	goto	cmd6a
	
	movf	counttmp,W
	movwf	INDF
	call	sendserial
	goto	mainloop

;***** [Command 07] Send RCV. & INC. command to PIC with Ret N-times *****
command7
	movlw	0x07
	movwf	INDF
	call	sendserial		; Echo back Serial Cmd
	call	recvserial
	movf	INDF,W
	movwf	piccommand
	call	sendserial		; Echo back PIC Cmd
	call	recvserial
	movf	INDF,W
	movwf	counter
	call	sendserial		; Echo back Counter-L
	call	recvserial
	movf	INDF,W
	movwf	counter+1
	call	sendserial		; Echo back Counter-H
	
	comf	counter,F		; 2's complement counter
	comf	counter+1,F
	incfsz	counter,F
	goto	cmd7a
	incf	counter+1,F
cmd7a	
	movf	piccommand,W
	call	sendcommand		;    RCV cmd. -> PIC
	call	receivedata		;    Data-HL  <- PIC
	movf	ispData0,W
	movwf	INDF
	call	sendserial		;    PC <- Data-L
	movf	ispData1,W
	movwf	INDF
	call	sendserial		;    PC <- Data-H
	movlw	0x06
	call	sendcommand		;    INC cmd. -> PIC

	incfsz	counter,F			; Count N-times
	goto	cmd7a
	incfsz	counter+1,F
	goto	cmd7a

	goto	mainloop

;***** [Command 08] Advanced Write 4 word *****
command8
	goto	command151

;***** [Command 09] Send 20 bit for PIC18 *****
command9
	movlw	D'5'
	movwf	advCount
	movlw	0x09
	movwf	INDF
	call	sendserial		; Echo back Serial Cmd
	movlw	advBuff
	movwf	FSR
command9a					; Receive Data 5 Byte
	call	recvserial
	incf	FSR,F
	decfsz	advCount,F
	goto	command9a

	clrf	advSum
	movlw	D'5'
	movwf	advCount
	movlw	advBuff
	movwf	FSR
command9s					; Calc Sum
	movf	INDF,W
	addwf	advSum,F
	incf	FSR,F
	decfsz	advCount,F
	goto	command9s
					; Send Command 4bit
	clrf	ispData0
	movf	advBuff+4,W
	btfsc	advBuff+3,1
	movwf	ispData0			;	Write P
cmd9c1
	movf	advBuff,W
	call	sendcommand4
	
	btfss	advBuff+3,0		; ID bit0='1'?
	goto	cmd9c3
	movf	advBuff+4,W		; wait after 4'th clock
	call	wait100usX
cmd9c3
	movf	advBuff+1,W		; Send Data 16bit
	movwf	ispData0
	movf	advBuff+2,W
	movwf	ispData1
	call	senddata16
	movlw	advSum
	movwf	FSR
	call	sendserial
	goto	mainloop

;***** [Command 0A] Receive 8 bit for PIC18 *****
commandA
	movlw	0x0A
	movwf	INDF
	call	sendserial
	call	recvserial
	clrf	ispData0
	movf	INDF,W
	call	sendcommand4
	call	receivedata8
	movf	ispData0,W
	movwf	INDF
	call	sendserial

	goto	mainloop

;***** [Command 0B] Address Set 24 bit for PIC18 *****
commandB
	movlw	D'3'
	movwf	advCount
	movlw	0x0B
	movwf	INDF
	call	sendserial		; Echo back Serial Cmd
	movlw	advBuff
	movwf	FSR
commandBa					; Receive Data 3 Byte
	call	recvserial
	incf	FSR,F
	decfsz	advCount,F
	goto	commandBa

	movf	advBuff,W		; Calc Sum
	movwf	advSum
	movf	advBuff+1,W
	addwf	advSum,F
	movf	advBuff+2,W
	addwf	advSum,F
	
	movlw	0x0E			; movf <AddrL>,W
	movwf	ispData1
	movf	advBuff,W
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	0x6E			; movwf 0xF6
	movwf	ispData1
	movlw	0xF6
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	0x0E			; movf <AddrH>,W
	movwf	ispData1
	movf	advBuff+1,W
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	0x6E			; movwf 0xF7
	movwf	ispData1
	movlw	0xF7
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	0x0E			; movf <AddrU>,W
	movwf	ispData1
	movf	advBuff+2,W
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	0x6E			; movwf 0xF8
	movwf	ispData1
	movlw	0xF8
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	advSum
	movwf	FSR
	call	sendserial

	goto	mainloop

;***** [Command 0C] Table Read N-Byte for PIC18 *****
commandC
	movlw	0x0C
	movwf	INDF
	call	sendserial		; Echo back Serial Cmd

	call	recvserial		; Rx N-L
	movf	INDF,W
	movwf	counter
	call	recvserial		; Rx N-H
	movf	INDF,W
	movwf	counter+1
	
	comf	counter,F		; 2's complement counter
	comf	counter+1,F
	incfsz	counter,F
	goto	cmdCa
	incf	counter+1,F

cmdCa	
	clrf	ispData0
	movlw	B'1001'			; Table Read *+
	call	sendcommand4
	call	receivedata8
	movf	ispData0,W
	movwf	INDF
	call	sendserial

	incfsz	counter,F		; Count N-times
	goto	cmdCa
	incfsz	counter+1,F
	goto	cmdCa
	goto	mainloop

;***** [Command 0D] Data Load 8 Byte for PIC18 *****
commandD
	movlw	D'9'
	movwf	advCount
	movlw	0x0D
	movwf	INDF
	call	sendserial		; Echo back Serial Cmd
	movlw	advTime+1
	movwf	FSR
commandDa					; Receive Data 9 Byte
	call	recvserial
	incf	FSR,F
	decfsz	advCount,F
	goto	commandDa

	clrf	advSum
	movlw	D'9'
	movwf	advCount
	movlw	advTime+1
	movwf	FSR
commandDs					; Calc Sum
	movf	INDF,W
	addwf	advSum,F
	incf	FSR,F
	decfsz	advCount,F
	goto	commandDs

	movlw	D'4'
	movf	advTime+1,F		; advTime+1 = 0 ?
	btfss	STATUS,Z
	movlw	D'3'
	movwf	advCount
	
	movlw	advData
	movwf	FSR
commandDl
	movf	INDF,W
	movwf	ispData0
	incf	FSR,F
	movf	INDF,W
	movwf	ispData1
	incf	FSR,F
	movlw	B'00001101'		; Table Write *+
	call	send20
	decfsz	advCount,F
	goto	commandDl
	
	movf	advTime+1,F
	btfsc	STATUS,Z
	goto	commandDe
	
	movf	advData+6,W
	movwf	ispData0
	movf	advData+7,W
	movwf	ispData1
	incf	FSR,F
	movlw	B'00001111'		; Table Write & Start Prog.
	call	send20
	
	movf	advTime+1,W
	movwf	ispData0
	movlw	0
	call	sendcommand4
	
	clrf	ispData0
	clrf	ispData1
	call	senddata16
commandDe
	movlw	advSum
	movwf	FSR
	call	sendserial	
	goto	mainloop

;***** [Command 0E] Address Set EEPROM for PIC18 *****
commandE
	movlw	0x0E
	movwf	INDF
	call	sendserial		; Echo back Serial Cmd

	call	recvserial		; Rx AddrL
	movf	INDF,W
	movwf	counter
	call	recvserial		; Rx AddrH
	movf	INDF,W
	movwf	counter+1
	
	movwf	advSum			; Calc Sum
	movf	counter,W
	addwf	advSum,F
	
	movlw	0x9E		; BCF EECON1, EEPGD
	movwf	ispData1
	movlw	0xA6
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	0x9C		; BCF EECON1, CFGS
	movwf	ispData1
	movlw	0xA6
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	0x0E		; movf <AddrL>,W
	movwf	ispData1
	movf	counter,W
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	0x6E		; movwf EEADR
	movwf	ispData1
	movlw	0xA9
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	0x0E		; movf <AddrH>,W
	movwf	ispData1
	movf	counter+1,W
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	0x6E		; movwf EEADRH
	movwf	ispData1
	movlw	0xAA
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	advSum
	movwf	FSR
	call	sendserial	
	goto	mainloop

;***** [Command 0F] EEPROM Read N-Byte for PIC18 *****
commandF
	movlw	0x0F
	movwf	INDF
	call	sendserial
	call	recvserial
	clrf	ispData0
	movf	INDF,W
	movwf	counter
commandFa
	movlw	0x80			; BSF EECON1,RD (Set RD bit)
	movwf	ispData1
	movlw	0xA6
	movwf	ispData0
	movlw	0
	call	send20

	movlw	0x50			; MOVF EEDATA,W,0
	movwf	ispData1
	movlw	0xA8
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	0x6E			; MOVWF TABLAT
	movwf	ispData1
	movlw	0xF5
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	0x00			; NOP
	movwf	ispData1
	movlw	0x00
	movwf	ispData0
	movlw	0
	call	send20
	
	movwf	ispData0			; Shift out TABLAT
	movlw	B'00000010'
	call	sendcommand4
	call	receivedata8
	movf	ispData0,W
	movwf	INDF
	call	sendserial
	
	movlw	0x2A			; INCF EEADR,F
	movwf	ispData1
	movlw	0xA9
	movwf	ispData0
	movlw	0
	call	send20
	
	decfsz	counter,F
	goto	commandFa

	goto	mainloop

;***** [Command 10]  for PIC18 *****
command10
	movlw	0x10
	movwf	INDF
	call	sendserial
	call	recvserial
	
	movf	INDF,W			; MOVLW <Data>
	movwf	ispData0
	movlw	0x0E
	movwf	ispData1
	movlw	0
	call	send20

	movlw	0x6E			; MOVWF EEDATA
	movwf	ispData1
	movlw	0xA8
	movwf	ispData0
	movlw	0
	call	send20

	movlw	0x84			; BSF EECON1,WREN
	movwf	ispData1
	movlw	0xA6
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	0x0E			; MOVLW 0x55
	movwf	ispData1
	movlw	0x55
	movwf	ispData0
	movlw	0
	call	send20

	movlw	0x6E			; MOVWF EECON2
	movwf	ispData1
	movlw	0xA7
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	0x0E			; MOVLW 0xAA
	movwf	ispData1
	movlw	0xAA
	movwf	ispData0
	movlw	0
	call	send20

	movlw	0x6E			; MOVWF EECON2
	movwf	ispData1
	movlw	0xA7
	movwf	ispData0
	movlw	0
	call	send20

	movlw	0x82			; BSF EECON1,WR
	movwf	ispData1
	movlw	0xA6
	movwf	ispData0
	movlw	0
	call	send20
EEWritePoll
	movlw	0x50			; MOVF EECON1,W,0
	movwf	ispData1			;   for Polling WR bit
	movlw	0xA6
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	0x6E			; MOVWF TABLAT
	movwf	ispData1
	movlw	0xF5
	movwf	ispData0
	movlw	0
	call	send20
	
	movlw	0x00			; NOP
	movwf	ispData1
	movlw	0x00
	movwf	ispData0
	movlw	0
	call	send20
ShiftoutTABLAT	
	movwf	ispData0			; Shift out TABLAT
	movlw	B'00000010'
	call	sendcommand4
	call	receivedata8
	
	btfsc	ispData0,1
	goto	EEWritePoll
	call	sendserial
	
	movlw	0x2A			; INCF EEADR,F
	movwf	ispData1
	movlw	0xA9
	movwf	ispData0
	movlw	0
	call	send20

	goto	mainloop

;***** [Command 151(Command 8)] Advance Write 4-word  *****
command151
	bsf		FSR,5
	movlw	D'13'
	movwf	advCount
	movlw	0x08
	movwf	INDF
	call	sendserial		; Echo back Serial Cmd
	movlw	advBuff
	movwf	FSR
command151a				; Receive Data 13 Byte
	call	recvserial

	incf	FSR,F
	decfsz	advCount,F
	goto	command151a

	movf	advCmd1,W
	movwf	advSum
	movlw	D'12'
	movwf	advCount
	movlw	advCmd2
	movwf	FSR
command151s				; Calc Sum
	movf	INDF,W
	addwf	advSum,F
	incf	FSR,F
	decfsz	advCount,F
	goto	command151s

	movlw	D'1'
	movwf	advLoadCnt
	movlw	D'4'
	movwf	advCount
	movlw	advData
	movwf	FSR
command151w
	movf	advCmd1,W
	call	sendcommand		; Send Command "Load"
	movf	INDF,W
	movwf	ispData0
	incf	FSR,F
	movf	INDF,W
	movwf	ispData1
	call	senddata		; Send Data "DataL DataH"
	incf	FSR,F
	movf	advLatch,W
	andwf	advLoadCnt,W
	bnz		WrSkip
	movf	advCmd2,W
	call	sendcommand		; Send Command "Begin Programming"
	movf	advTime,W
	call	wait100usX		; Wait 100 x N usec
	movf	advCmd3,W
	bz		WrSkip
	call	sendcommand		; Send Command "End Programming"
WrSkip
	movlw	0x06
	call	sendcommand		; Send Command "Increment Address"
	incf	advLoadCnt,F
	decfsz	advCount,F
	goto	command151w

	movlw	advSum
	movwf	FSR
	call	sendserial		; Tx Sum Data

	bcf		FSR,5
	goto	mainloop

;; expand command
commandFF
	movlw	0xff
	movwf	INDF
	call	sendserial		; Echo back Command ff
	call	recvserial
	movf	INDF,W
	bz		txver2			; Command ff - 00 Tx Ver. string
	movlw	0x01
	subwf	INDF,W
	bnz		cmdFF_2
	call	powupvddpgm		; Command ff - 01 Power-UP Vdd befor PGM
	movlw	0x01
	movwf	INDF
	call	sendserial
	goto	mainloop
cmdFF_2	
	movlw	0x02
	subwf	INDF,W
	bnz		cmdFF_ff
	call	powdnpgmvdd		; Command ff - 02 Power-DOWN PGM befor Vdd
	movlw	0x02
	movwf	INDF
	call	sendserial
	goto	mainloop
cmdFF_ff	
	movlw	0xff
	subwf	INDF,W
	bnz		mainloop
	movlw	0xff
	movwf	INDF
	call	sendserial
	call	recvserial
	movf	INDF,W
	sublw	0x05
	btfss	STATUS,C
	movlw	0x03			; default 2:38400
	sublw	0x05
	movwf	INDF
	call	sendserial
	movf	INDF,W
	call 	eeprom_write
	movf	INDF,W
	movwf	bpsno
	call	numbps
	call	setbps

	goto	mainloop

;;;;;; subroutine :I/O control ;;;

;***** Power UP Vdd befor Vpp *****
;	Vdd ON -> 10us -> Vpp ON     Command 00 - 01
powupvddvpp
	setcdout
	call	wait10us
	vddhi
	call	wait10us
	vpphi
	call	wait10us
	ledon
	retlw	0

;***** Power DOWN Vpp befor Vdd *****
;	Vpp OFF -> 10us Vdd OFF     Command 00 - 02
powdnvppvdd
	vpplo
	call	wait10us
	vddlo
	call	wait10us
	ledoff
	setdefout
	retlw	0

;***** Power UP Vpp befor Vdd *****
;	Vpp ON -> 10us -> Vdd ON     Command 00 - 03
powupvppvdd
	setcdout
	call	wait10us
	vpphi
	call	wait10us
	vddhi
	call	wait10us
	ledon
	retlw	0

;***** Power DOWN Vdd befor Vpp *****
;	Vdd OFF -> 10us -> Vpp OFF     Command 00 - 04
powdnvddvpp
	vddlo
	call	wait10us
	vpplo
	call	wait10us
	ledoff
	setdefout
	retlw	0

;***** Define Variable for Send Command, Send Data,Receive Data
	cblock
	ispCommand:1
	ispData0:1
	ispData1:1
	scCount:1
	endc

;***** Send Command *****
;     w: Send command (6bit)
sendcommand
	movwf	ispCommand
	setcdout

	movlw	D'6'
	movwf	scCount
scloop	
	clkhi
	rrf		ispCommand,F
	bc		sch
;	nop
	datlo
	goto	scle
sch	
	dathi
;	nop
;	nop
scle	
	nop
	clklo
;	nop
	decfsz	scCount,F
	goto	scloop
	datlo
	retlw	0

;***** Send Data *****
;     ispData0,ispData1: Send Data(14 or 12bit)
senddata
	setcdout

	bcf		STATUS,C
	rlf		ispData0,F
	rlf		ispData1,F
	movlw	D'16'
	movwf	scCount
sdloop	
	clkhi
	rrf		ispData1,F
	rrf		ispData0,F
	bc		sdh
;	nop
	datlo
	goto	sdle
sdh	
	dathi
;	nop
;	nop
sdle	
;	nop
	nop
	clklo
;	nop
	decfsz	scCount,F
	goto	sdloop
	datlo
	retlw	0

;***** Receive Data *****
;
;     ispData0,ispData1: Receive Data(14 or 12bit)
;
receivedata
	setcout

	movlw	D'16'
	movwf	scCount
rdloop	
	clkhi
	bcf		STATUS,C
	skipdatlo
	bsf		STATUS,C
	rrf		ispData1,F
	rrf		ispData0,F
	clklo
	decfsz	scCount,F
	goto	rdloop
	bcf		STATUS,C
	rrf		ispData1,F
	rrf		ispData0,F

	datlo
	setcdout
;	setdefout
	retlw	0

;***** Send Command 4bit for PIC18 *****
;     w: Send command (4bit)
;     ispData0: Wait time at 4'th clock 'H'
sendcommand4
	movwf	ispCommand
	setcdout

	movlw	D'3'
	movwf	scCount
sc4a
	clkhi
	dathi
	rrf		ispCommand,F
	btfss	STATUS,C
	datlo
	nop
	clklo
	decfsz	scCount,F
	goto	sc4a
	
	clkhi
	dathi
	rrf		ispCommand,F
	btfss	STATUS,C
	datlo

	movf	ispData0,F
	btfsc	STATUS,Z
	goto	sc4b
	movf	ispData0,W		; wait at 3'rd clock 'H'
	call	wait100usX
sc4b
	clklo
	call	wait100us

	retlw	0

;***** Send Data 16bit for PIC18 *****
;     ispData0,ispData1: Send Data(16bit)
senddata16
	setcdout

	movlw	D'16'
	movwf	scCount
sd16loop
	clkhi
	dathi
	rrf		ispData1,F
	rrf		ispData0,F
	btfss	STATUS,C
	datlo
	nop
	clklo
	decfsz	scCount,F
	goto	sd16loop
	datlo
	retlw	0

;***** Send Command 4bit & Data 16bit for PIC18 *****
;     w: Send command (4bit)
;     ispData0,ispData1: Send Data(16bit)
send20
	movwf	ispCommand
	setcdout

	movlw	D'4'
	movwf	scCount
sd20c
	clkhi
	dathi
	rrf		ispCommand,F
	btfss	STATUS,C
	datlo
	nop
	clklo
	decfsz	scCount,F
	goto	sd20c

	movlw	D'16'
	movwf	scCount
sd20d	
	clkhi
	dathi
	rrf		ispData1,F
	rrf		ispData0,F
	btfss	STATUS,C
	datlo
	nop
	clklo
	decfsz	scCount,F
	goto	sd20d
	datlo
	retlw	0

;***** Receive Data 8bit for PIC18 *****
;
;     ispData0: Receive Data(8bit)
;
receivedata8
	setcout

	movlw	D'16'
	movwf	scCount
rd8loop	
	clkhi
	bcf		STATUS,C
	skipdatlo
	bsf		STATUS,C
	rrf		ispData0,F
	clklo
	decfsz	scCount,F
	goto	rd8loop

	retlw	0


;***** Power UP Vdd befor PGM *****
;	Vdd ON -> 10us -> PGM ON  -> 10us -> MCLR 5V  Command ff - 01
powupvddpgm
	setcdout
	call	wait10us
	vddhi
	call	wait10us
	pgmhi
	call	wait10us
	mclr5hi

	ledon
	retlw	0

;***** Power DOWN PGM befor Vdd *****
;	MCLR OFF -> Vpp OFF -> 10us Vdd OFF     Command ff - 02
powdnpgmvdd
	mclr5lo
	call	wait10us
	pgmlo
	call	wait10us
	vddlo
	call	wait10us
	ledoff
	setdefout
	retlw	0

;;;;;; subroutine: etc  ;;;;;;;;;;
;***** Tx Version string *****
txver
	movlw	buffer
	movwf	FSR
	clrf	INDF		; Echo back 0x00 (sub-command)
	call	sendserial
	clrf	PCLATH
	clrf	stridx		; stridx = 0
	movlw	strend-verstr-1	; counter = Length
	movwf	counter
txvloop	
	movf	stridx,W
	call	verstr
	movwf	INDF
	call	sendserial
	incf	stridx,F
	decfsz	counter,F
	goto	txvloop
	goto	mainloop
	
eeprom_write
	bsf		STATUS,RP0	; Set BANK1
	clrf	EEADR
	movwf	EEDATA
	bsf		EECON1,WREN		;write step 1
	movlw	0x55
	movwf	EECON2			;step 2
	movlw	0xAA
	movwf	EECON2			;step 3
	bsf		EECON1,WR		;start	step 4
	bcf		EECON1,WREN
	btfsc	EECON1,WR		;WR clr?	step 5
	goto	$-1				;no to loop
	bcf		STATUS,RP0
	return

eeprom_read
	bsf		STATUS,RP0
	clrf	EEADR
	bsf		EECON1,RD
	movf	EEDATA,W
	bcf		STATUS,RP0
	return

numbps
	movwf	tmp
	addlw	0
	btfsc	STATUS,Z
	retlw	0x3b 	;9600bps
	decf	tmp,F
	btfsc	STATUS,Z
	retlw	0x1d	;19200bps
	decf	tmp,F
	btfsc	STATUS,Z
	retlw	0x0e	;38400bps
	decf	tmp,F
	btfsc	STATUS,Z
	retlw	0x09	;57600bps
	decf	tmp,F
	btfsc	STATUS,Z
	retlw	0x04	;115200bps
	retlw	0x0e	;38400bps

txver2
	movlw	buffer
	movwf	FSR
	clrf	INDF		; Echo back 0x00 (sub-command)
	call	sendserial
	clrf	PCLATH
	clrf	stridx		; stridx = 0
	movlw	strend2-verstr2-1	; counter = Length
	movwf	counter
txvloop2
	movf	stridx,W
	call	verstr2
	movwf	INDF
	call	sendserial
	incf	stridx,F
	decfsz	counter,F
	goto	txvloop2
	goto	mainloop

wait100usX
	movwf	WaitCounter
	call	wait100us
wait100usXLoop
	decfsz	WaitCounter,F
	goto	$+2
	retlw	0
	call	wait100us
	goto	wait100usXLoop

;***** VARIABLE DEFINITIONS
	cblock
	stridx:1
	tmp:1
	bpsno:1
	WaitCounter:1
	endc

;;;;;; subroutine: time ;;;;;;;;;;

; 1cycle = 1000000us/9220000Hz*4=0.44us

;   10us = 23cycle
wait10us		;  2
	goto $+1	;  4
	goto $+1	;  6
	goto $+1	;  8
	goto $+1	; 10
	goto $+1	; 12
	goto $+1	; 14
	goto $+1	; 16
	goto $+1	; 18
	goto $+1	; 20
	nop			; 21
	return		; 23

;	100us = 230cycle
wait100us			;   2
	call wait10us	;  25
	call wait10us	;  48
	call wait10us	;  71
	call wait10us	;  94
	call wait10us	; 117
	call wait10us	; 140
	call wait10us	; 163
	call wait10us	; 186
	call wait10us	; 209
	goto $+1		; 211
	goto $+1		; 213
	goto $+1		; 215
	goto $+1		; 217
	goto $+1		; 219
	goto $+1		; 221
	goto $+1		; 223
	goto $+1		; 225
	goto $+1		; 227
	nop				; 228
	return			; 230

wait25ms
	movlw 0x06
wait25loop
	addlw 1
	btfsc STATUS,C
	return
	call  wait100us
	goto  wait25loop

wait100ms
	call wait25ms
	call wait25ms
	call wait25ms
	call wait25ms
	return

;;;;;; subroutine: serial ;;;;;;;;
recvserial
	btfss	PIR1, 5
	goto	recvserial
	btfsc   RCSTA,FERR
	goto	frameerr
	btfsc   RCSTA,OERR
	goto	overerr

	movf	RCREG, W  ; data in
	movwf	INDF
	retlw	0

frameerr
	movf	RCREG, W
	btfss	RCSTA,OERR
	retlw	1
overerr
	bcf		RCSTA,CREN
	bsf		RCSTA,CREN
	retlw	1

sendserial
	movf	INDF, W
	bsf		STATUS,RP0
ssloop
	btfss	TXSTA, 1
	goto	ssloop
	bcf		STATUS,RP0

	movwf	TXREG     ; data out
	retlw	0

setbps
	clrf	RCSTA
	nop
	bsf		STATUS,RP0
	clrf	TXSTA
	nop
	movwf	SPBRG
	movlw	B'00100100'     
	movwf	TXSTA
	bcf		STATUS,RP0
	movlw	B'10010000'
	movwf	RCSTA
	return

;;;; eeprom ;;;;;;;;;;;;;;;;;;;;;;;
	ORG		0x2100
	DE		0x02	; 0:9600, 1: 19200, 2:38400, 3:57600, 4:115200
	END
